﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Threading;
using System.Net;
using System.IO;

namespace webserver1
{
    class Program
    {
        static Semaphore sem;

        static void Main(string[] args)
        {   
            //支持模拟20个连接
            sem = new Semaphore(20, 20);
            
            HttpListener listener = new HttpListener();
            string url = "http://localhost/";
            listener.Prefixes.Add(url);
            listener.Start();
            
            Task.Run(() =>
            {   
                while (true) {
                    sem.WaitOne();
                                        
                    StartConnectionListener(listener);
                }
            });

            Console.WriteLine("点击任意键，退出WebServer");
            Console.ReadLine();
        }

        static async void StartConnectionListener(HttpListener listener)
        {
            // 等待连接。
            HttpListenerContext context = await listener.GetContextAsync();

            //释放信号器，另外一个监听器可以立刻开启
            sem.Release();
            
            //获得请求对象
            HttpListenerRequest request = context.Request;
            HttpListenerResponse response = context.Response;
            // 在URL路径上截取文件名称， 介于 "/" 和 "?"之间
            string path = request.RawUrl.LeftOf("?").RightOf("/");
            Console.WriteLine(path);
            //输出一些内容
            try
            {   
                // 加载文件并以UTF-8的编码返回
                string text = File.ReadAllText(path);
                byte[] data = Encoding.UTF8.GetBytes(text);
                response.ContentType = "text/html";
                response.ContentLength64 = data.Length;
                response.OutputStream.Write(data, 0, data.Length);
                response.ContentEncoding = Encoding.UTF8;

                response.StatusCode = 200;
                
                response.OutputStream.Close();
            }
            catch (Exception ex) { Console.WriteLine(ex.Message); }

        }
    }
}
